﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.TimelineView;
using Infragistics.Win.UltraWinScrollBar;

namespace WTLV_NumberOfDaysVisible
{
    class CustomCreationFilter : IUIElementCreationFilter
    {
        int headerWidth = -1;
        int scrollBarWidth = -1;

        public int HeaderWidth
        {
            get { return headerWidth; }
            set { headerWidth = value; }
        }

        public int ScrollBarWidth
        {
            get { return scrollBarWidth; }
            set { scrollBarWidth = value; }
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is ScrollBarUIElement)
            {
                if (scrollBarWidth != -1)
                    return;

                var context = (Orientation)parent.GetContext(typeof(Orientation));

                if (context == Orientation.Vertical)
                {
                    scrollBarWidth = parent.Rect.Width;
                }
            }

            if (parent is OwnerHeaderUIElement)
            {
                if (headerWidth == -1)
                {
                    headerWidth = parent.Rect.Width;
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
